//generic functions that are shared among different projects
//WARNING: you should unlock all DDraw surfaces before 
//calling any function in this file:
//  lpDDraw->Unlock(lpDDSurface); //from .cpp
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "util0.h"

void ProgrammerError(char*ErrInfo)
//if this happens, we really screwed up.
{
  //if (GlobalNotifyMajorError(ErrInfo))
  MessageBox(NULL,ErrInfo,"Programmer Error",MB_TASKMODAL);
}
void DefMsgBox(char*ptxt)
{
  MessageBox(NULL,ptxt,"Info",MB_TASKMODAL);
}

static DWORD GetMemCnt=0,FreeMemCnt=0;
int CheckMemory() //call this before program exits
{int mdif;

  mdif=FreeMemCnt-GetMemCnt;
  FreeMemCnt=GetMemCnt=0;
  if (mdif) ProgrammerError("bad memory usage count");
  return mdif;
}

void*GetMem(long size)
{void* bufptr;
 
  bufptr=VirtualAlloc(NULL,size,MEM_COMMIT|MEM_RESERVE,PAGE_READWRITE);
  if (NULL!=bufptr) GetMemCnt++;
  return(bufptr);
}

int FreeMem(void*mem_ptr)
{int retval;

  if (NULL==mem_ptr) {
#ifdef _DEBUG
    ProgrammerError("trying to free NULL pointer");
#endif
    retval=1;
  } else if (0==VirtualFree(mem_ptr,0,MEM_RELEASE)) {
#ifdef _DEBUG
    ProgrammerError("FreeMem() failed");
#endif
    retval=-1;
  } else { 
    FreeMemCnt++; retval=0;
  }
  return retval;
}

